unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Mask, ToolEdit, Registry,ShlObj,activex,ComOBJ,
  ExtCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ChngPixBox: TCheckBox;
    ChngSoundBox: TCheckBox;
    ChngHintMCBox: TCheckBox;
    Label1: TLabel;
    PicDirectory: TDirectoryEdit;
    Label2: TLabel;
    StartSoundDirectory: TDirectoryEdit;
    Label3: TLabel;
    QuitSoundDirectory: TDirectoryEdit;
    Label4: TLabel;
    MyComputerTextFile: TFilenameEdit;
    AutoRunBox: TCheckBox;
    Button1: TButton;
    TabSheet3: TTabSheet;
    LastPictureLabel: TLabel;
    Button2: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure AutoRunBoxClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ChngPixBoxClick(Sender: TObject);
  private
    { Private declarations }
    StartupFolder : string;  { }
    DesktopFolder : string;  {  }
    procedure AddShortcut(var folder:string);
    procedure SaveDatas;  //    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$I const.inc}
{$R *.DFM}
function CreateShortcut(const CmdLine, Args, WorkDir, LinkFile: string):IPersistFile;
  var
    MyObject  : IUnknown;
    MySLink   : IShellLink;
    MyPFile   : IPersistFile;
    WideFile  : WideString;
  begin
    MyObject := CreateComObject(CLSID_ShellLink);
    MySLink := MyObject as IShellLink;
    MyPFile := MyObject as IPersistFile;
    with MySLink do
    begin
      SetPath(PChar(CmdLine));
      SetArguments(PChar(Args));
      SetWorkingDirectory(PChar(WorkDir));
    end;

    WideFile := LinkFile;
    MyPFile.Save(PWChar(WideFile), False);
    Result := MyPFile;
  end;

procedure TForm1.AddShortcut(var folder:string);
var
  ProgramName : string;
  ExecDir     : string;
begin
  ProgramName :=ParamStr(0);
  ExecDir := ExtractFilePath(ProgramName);
  CreateShortcut(ProgramName,'Change', ExecDir,folder+ShortcutName);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Reg : TRegistry;
  ItemIDList: PItemIDList;
  Path : array[0..100] of char;
begin
  SHGetSpecialFolderLocation(Handle,CSIDL_STARTUP,ItemIDList);
  SHGetPathFromIDList(ItemIDList,@Path);
  StartupFolder:=Path;
  SHGetSpecialFolderLocation(Handle,CSIDL_DESKTOP,ItemIDList);
  SHGetPathFromIDList(ItemIDList,@Path);
  DesktopFolder:=Path;

  AutoRunBox.Checked:=FileExists(StartupFolder+ShortcutName);

  Reg := TRegistry.Create;
   try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey(RegPath,true)
     then begin
       if Reg.ValueExists(ChangeWallpaper)
        then ChngPixBox.Checked:=Reg.ReadBool(ChangeWallpaper)
        else ChngPixBox.Checked:=false;
       if Reg.ValueExists(RandomWallpapper)
        then begin
          RadioButton2.Checked:=Reg.ReadBool(RandomWallpapper);
          RadioButton1.Checked:=not RadioButton2.Checked;
        end;
       if Reg.ValueExists(ChangeSounds)
        then ChngSoundBox.Checked:=Reg.ReadBool(ChangeSounds)
        else ChngSoundBox.Checked:=false;
       if Reg.ValueExists(ChangeHintMyComputer)
        then ChngHintMCBox.Checked:=Reg.ReadBool(ChangeHintMyComputer)
        else ChngHintMCBox.Checked:=false;
       if Reg.ValueExists(PicturesPath)
        then PicDirectory.Text:=Reg.ReadString(PicturesPath)
        else PicDirectory.Text:='';
       if Reg.ValueExists(StartSoundPath)
        then StartSoundDirectory.Text:=Reg.ReadString(StartSoundPath)
        else StartSoundDirectory.Text:='';
       if Reg.ValueExists(QuitSoundPath)
        then QuitSoundDirectory.Text:=Reg.ReadString(QuitSoundPath)
        else QuitSoundDirectory.Text:='';
       if Reg.ValueExists(MyCompTextFile)
        then MyComputerTextFile.Text:=Reg.ReadString(MyCompTextFile)
        else MyComputerTextFile.Text:='';
       if Reg.ValueExists(LastPicture)
        then LastPictureLabel.Caption:=Reg.ReadString(LastPicture);
     end
   finally
    Reg.CloseKey;
    Reg.Free;
   end;
   ChngPixBoxClick(@Self);
end;

procedure TForm1.SaveDatas;
var
  Reg : TRegistry;
begin
  Reg := TRegistry.Create;
   try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey(RegPath,true)
     then begin
       Reg.WriteBool(ChangeWallpaper,ChngPixBox.Checked);
       Reg.WriteBool(RandomWallpapper,RadioButton2.Checked);
       Reg.WriteBool(ChangeSounds,ChngSoundBox.Checked);
       Reg.WriteBool(ChangeHintMyComputer,ChngHintMCBox.Checked);
       Reg.WriteString(PicturesPath,PicDirectory.Text);
       Reg.WriteString(StartSoundPath,StartSoundDirectory.Text);
       Reg.WriteString(QuitSoundPath,QuitSoundDirectory.Text);
       Reg.WriteString(MyCompTextFile,MyComputerTextFile.Text);
     end
   finally
    Reg.CloseKey;
    Reg.Free;
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 SaveDatas
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 AddShortcut(DesktopFolder);
end;

procedure TForm1.AutoRunBoxClick(Sender: TObject);
begin
 if not AutoRunBox.Checked
   then DeleteFile(StartupFolder+ShortcutName)
   else AddShortcut(StartupFolder);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  si: TStartupInfo;
  p:  TProcessInformation;
  s: string;
  Reg : tRegistry;
begin
  s:=ParamStr(0)+' Change'+#0;
  FillChar(Si,SizeOf(Si),0);
  with Si do begin
    cb := SizeOf( Si);
    dwFlags := startf_UseShowWindow;
    wShowWindow := 4;
  end;
  SaveDatas;
  Form1.WindowState:=wsMinimized;
  Createprocess(nil,@s[1],nil,nil,false,
    Create_default_error_mode,nil,nil,si,p);
  Waitforsingleobject(p.hProcess,infinite);
  Form1.WindowState:=wsNormal;

  Reg := TRegistry.Create;
   try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey(RegPath,true) and Reg.ValueExists(LastPicture)
     then LastPictureLabel.Caption:=Reg.ReadString(LastPicture);
   finally
    Reg.CloseKey;
    Reg.Free;
   end;
end;

procedure TForm1.ChngPixBoxClick(Sender: TObject);
begin
  RadioButton1.Enabled:=ChngPixBox.Checked;
  RadioButton2.Enabled:=ChngPixBox.Checked;
end;

end.
